--!parent
--!encoding=utf-8

--****************************************************************************
-- @file LSW CORE LIB: MIAW
-- @author Valentin Schmidt
-- @version 0.1
-- Important: file "empty.dir" must be write-protected in the fileystem to 
-- allow multiple MIAWs at once.
--****************************************************************************

----------------------------------------
-- @constructor
----------------------------------------
on new (me)
	return me
end

----------------------------------------
-- Factory method: creates and returns a new MIAW
-- @param {propList} props
-- @param {string} [name="miaw"]
-- @param {string} [file]
-- @return {window}
----------------------------------------
on make (me, props, name, file)
	if voidP(name) then name = "miaw"
	if voidP(file) then file = me.libdir & "empty.dir"
	w = window().new(name)
	w.filename = file
	if ilk(props)=#propList then
		cnt = count(props)
		repeat with i = 1 to cnt
			do("w."&props.getPropAt(i)&"=props[i]")
		end repeat
	end if
	return w
end
